<?php
class Mini extends ChatMe {
	
	static $instance = false;
        
    public function __construct() {
        add_action('wp_head',       array( $this, 'chatme_mini_wp_head') );
        add_action('admin_menu',    array( $this, 'chatme_mini_admin_menu') );
        add_action('admin_init',    array( $this, 'chatme_mini_admin_init') );
        $this->resource             = $_SERVER['SERVER_NAME'];
    }
	
	public static function getInstance() {
		if ( !self::$instance )
			self::$instance = new self;
		return self::$instance;
	}
    
      	function chatme_mini_add_help_tab () {
          	$screen = get_current_screen();

          	$screen->add_help_tab( array(
              	      	'id'		=> 'chatme_mini_help_tab_1',
              	      	'title'		=> __('anonymous server', 'chatmeim-mini'),
              	      	'content'	=> '<p>' . __( 'The anonymous server of your XMPP service, default: anonymous.chatme.im', 'chatmeim-mini' ) . '</p>',
          	      	) );

          	$screen->add_help_tab( array(
              	      	'id'		=> 'chatme_mini_help_tab_2',
              	      	'title'		=> __('Chat rooms password', 'chatmeim-mini'),
              	      	'content'	=> '<p>' . __( 'This is the password of chat room where the user enter when click the chat button, remeber that <b>password is visble in HTML code</b> of page and <b>it is not possible to hide it.</b>', 'chatmeim-mini' ) . '</p>',
          	      	) );

          	$screen->set_help_sidebar(
                              __('<p><strong>Other Resources</strong></p><p><a href="https://jappix.org/" target="_blank">Jappix Official Site</a></p><p><a href="https://github.com/jappix/jappix/wiki" target="_blank">Jappix Official Documentation</a></p><p><a href="http://xmpp.net" target="_blank">XMPP.net</a></p><p><a href="http://chatme.im" target="_blank">ChatMe Site</a></p>', 'chatmeim-mini')
                             );
      	      	}

    function chatme_mini_wp_head() {
	
	$chat = '';
        $current_user = wp_get_current_user();
		
		$setting = array(
				'jappix_url' 		=> esc_url(get_option('custom')),
				'anonymous'		=> esc_html(get_option('custom-server')),
				'adminjid'		=> esc_html(get_option('admin_site')),
				'dlng' 			=> esc_html(get_option('language')),
				'auto_login' 		=> esc_html(get_option('auto_login')),
	    			'animate' 		=> esc_html(get_option('animate')),
	    			'auto_show' 		=> esc_html(get_option('auto_show')),
				'default_room' 		=> esc_html(get_option('join_groupchats')),
				'nickname'		=> $current_user->display_name,	
				'resource'		=> $this->resource,
				'loggedonly'		=> esc_html(get_option('all')),		
				'style'			=> wp_kses(get_option('style'), ''),	
				'icon' 			=> esc_url(get_option('icon')),	
				'mini_disable_mobile' 	=> esc_html(get_option('mini_disable_mobile')),	
				'priority'		=> esc_html(get_option('priority')),
				'open_passwords'	=> wp_kses(get_option('open_passwords'),''),
				'bind_mini' 		=> wp_kses(get_option('bind_mini'),''),
						);
						
		foreach( $setting as $k => $settings )
			if( false == $settings )
				unset( $setting[$k]);
						
		$actual = apply_filters( 'chat_actual', wp_parse_args( $setting, $this->default ) );
        
	if (!$actual['loggedonly'] || is_user_logged_in()) {
        
	$chat = printf( '
    <style type="text/css">
    %s
    #jappix_mini .jm_images_animate { background-image: url(\'%s\') !important; background-repeat: no-repeat;}
    </style>
    <link rel="dns-prefetch" href="%s"/>		
    <link rel="dns-prefetch" href="%s"/>		
    <script>
	jQuery(document).ready(function(chat) {
        	chat.ajaxSetup({cache: %s});
        	chat.getScript("%s/server/get.php?l=%s&t=js&g=mini.xml", function() {
		HOST_BOSH_MINI = "%s"

        	JappixMini.launch({
            		connection: {
                		domain: "%s",
				resource: "%s",
				priority: %s,
           		},

            		application: {
                		network: {
                    			autoconnect: %s,
                			},

                	interface: {
                    		showpane: true,
                    		animate: %s,
                    		no_mobile: %s,
                    		error_link: "%s",
                		},

                	user: {
                    		random_nickname: false,
                    		nickname: "%s",
                		},

                	chat: {
                    		suggest: ["%s"],
                		},

                	groupchat: {
                    		open: ["%s"],
		    		open_passwords: ["%s"],
                    		suggest: ["piazza@conference.chatme.im","support@conference.chatme.im"],
                		},
            		},
        	});
    	});
})
</script>', 
			$actual['style'],
			$actual['icon'],
			$actual['jappix_url'],
			$actual['bind_mini'],
			$actual['chatme_cache'],
			$actual['jappix_url'],	
			$actual['dlng'],
			$actual['bind_mini'],			
			$actual['anonymous'],
			$actual['resource'],
			$actual['priority'],
			$actual['auto_login'],
			$actual['animate'],
			$actual['mini_disable_mobile'],
			$actual['mini_error_link'],
			$actual['nickname'],
			$actual['adminjid'],
			$actual['default_room'],
			$actual['open_passwords']
		);
	}	
    return apply_filters( 'chat_html', $chat );
	}

    function chatme_mini_admin_menu() {
        $my_admin_page = add_options_page( __('ChatMe Mini Options', 'chatmeim-mini'), __('ChatMe Mini', 'chatmeim-mini'), 'manage_options', $this->default['plugin_options_key'], array($this, 'chatme_mini_options') );
        add_action('load-'.$my_admin_page, array( $this, 'chatme_mini_add_help_tab') );
    }

    function chatme_mini_admin_init() {
		//register our settings
		register_setting('mini_chat', 'custom');
		register_setting('mini_chat', 'custom-server');
		register_setting('mini_chat', 'language');
		register_setting('mini_chat', 'auto_login');
		register_setting('mini_chat', 'auto_show');
		register_setting('mini_chat', 'animate');
		register_setting('mini_chat', 'join_groupchats');
		register_setting('mini_chat', 'admin_site');
       		register_setting('mini_chat', 'all');
        	register_setting('mini_chat', 'style');
        	register_setting('mini_chat', 'icon'); 
        	register_setting('mini_chat', 'mini_disable_mobile');     
        	register_setting('mini_chat', 'priority');   
        	register_setting('mini_chat', 'open_passwords');   
        	register_setting('mini_chat', 'bind_mini');
    }

    function chatme_mini_options() {
        if (!current_user_can('manage_options'))  {
        wp_die( __('You do not have sufficient permissions to access this page.', 'chatmeim-mini') );
    }
?>
 <div class="wrap">
<h1>ChatMe Mini</h1>
<p><?php _e("For more information visit <a href='http://www.chatme.im' target='_blank'>www.chatme.im</a>", 'chatmeim-mini'); ?> - <?php _e('<a href="https://webchat.chatme.im/?r=support" target="_blank">Support Chat Room</a>', 'chatmeim-mini'); ?> - <?php _e('<a href="http://chatme.im/prodotto/servizio-im-proprio-dominio/" target="_blank">Enable Chat service in your domain</a>', 'chatmeim-mini'); ?></p>
<p><?php _e("For subscribe your account visit <a href='http://chatme.im/servizi/domini-disponibili/' target='_blank'>http://chatme.im/servizi/domini-disponibili/</a>", 'chatmeim-mini'); ?></p>

<form method="post" action="options.php">
    <?php settings_fields( 'mini_chat' ); ?>
    <table class="form-table">

		<tr valign="top">
        <th scope="row"><label for="custom"><?php _e("Insert a custom Jappix Installation url", 'chatmeim-mini'); ?></label></th>
        <td><input class="regular-text" aria-describedby="custom-description" type="url" size="50" id="custom" name="custom" placeholder="<?php _e("https://webchat.chatme.im", 'chatmeim-mini'); ?>" value="<?php echo get_option('custom'); ?>" /> /server/get.php...<p class="description" id="custom-description"><?php _e("Insert your Jappix installation URL", 'chatmeim-mini'); ?></p></td>
        </tr>

		<tr valign="top">
        <th scope="row"><label for="bind_mini"><?php _e("Insert a custom Bind Server URL", 'chatmeim-mini'); ?></label></th>
        <td><input class="regular-text" aria-describedby="bind_mini-description" type="text" size="50" id="bind_mini" name="bind_mini" placeholder="<?php _e("https://bind.chatme.im", 'chatmeim-mini'); ?>" value="<?php echo get_option('bind_mini'); ?>" /><p class="description" id="bind_mini-description"><?php _e("If you use a local XMPP server or a XMPP without SRV record in DNS you must enter a custom bind server", 'chatmeim-mini'); ?></p></td>
        </tr>

		<tr valign="top">
        <th scope="row"><label for="custom-server"><?php _e("Insert your custom anonymous server", 'chatmeim-mini'); ?></label></th>
        <td><input class="regular-text" type="text" id="custom-server" name="custom-server" placeholder="<?php _e("anonymous.chatme.im", 'chatmeim-mini'); ?>" value="<?php echo get_option('custom-server'); ?>" /></td>
        </tr>
            
        <tr valign="top">
        <th scope="row"><label for="auto_login"><?php _e("Auto login to the account", 'chatmeim-mini'); ?></label></th>
        <td><input type="checkbox" id="auto_login" name="auto_login" value="true" <?php checked('true', get_option('auto_login')); ?> /></td>
        </tr>
		
		<tr valign="top">
        <th scope="row"><label for="auto_show"><?php _e("Auto show the opened chat", 'chatmeim-mini'); ?></label></th>
        <td><input type="checkbox" id="auto_show" name="auto_show" value="true" <?php checked('true', get_option('auto_show')); ?> /></td>
        </tr>

		<tr valign="top">
        <th scope="row"><label for="animate"><?php _e("Display an animated image when the user is not connected", 'chatmeim-mini'); ?></label></th>
        <td><input type="checkbox" id="animate" name="animate" value="true" <?php checked('true', get_option('animate')); ?> /><br />
	<input class="regular-text" aria-describedby="animate-description" type="url" size="50" name="icon" placeholder="<?php _e("Custom Icon URL", 'chatmeim-mini'); ?>" value="<?php echo get_option('icon'); ?>" /><p class="description" id="animate-description"><?php _e("Insert your custom icon url, default: https://webchat.chatme.im/app/images/sprites/animate.png size: 80x74 px", 'chatmeim-mini'); ?></p>
	</td>
        </tr>
		
		<tr valign="top">
        <th scope="row"><label for="join_groupchats"><?php _e("Chat rooms to join (if any)", 'chatmeim-mini'); ?></label></th>
        <td><input aria-describedby="join_groupchats-description" class="regular-text" type="text" id="join_groupchats" name="join_groupchats" placeholder="<?php _e("piazza@conference.chatme.im", 'chatmeim-mini'); ?>" value="<?php echo get_option('join_groupchats'); ?>" /><p class="description" id="join_groupchats-description"><?php _e('For create a Chat Room use Desktop <a href="http://chatme.im/elenco-client/" target="_blank">Client</a> or go to <a href="https://conference.chatme.im/chat.php" target="_blank">Here.</a>', 'chatmeim-mini'); ?></p></td>
        </tr>

		<tr valign="top">
        <th scope="row"><label for="open_passwords"><?php _e("Chat rooms password", 'chatmeim-mini'); ?></label></th>
        <td><input aria-describedby="open_passwords-description" class="regular-text" type="password" id="open_passwords" name="open_passwords" placeholder="<?php _e("Chat Room Password", 'chatmeim-mini'); ?>" value="<?php echo wp_kses(get_option('open_passwords'),''); ?>" /><p class="description" id="open_passwords-description"><?php _e("The password of Chat Room, please attention the password is visible in HTML code ", 'chatmeim-mini'); ?></p></td>
        </tr>
        
        <tr valign="top">
	    <th scope="row"><label for="admin_site"><?php _e("Chat with site admin", 'chatmeim-mini'); ?></label></th>
	    <td><input class="regular-text" type="text" id="admin_site" name="admin_site" placeholder="<?php _e("admin", 'chatmeim-mini'); ?><?php echo $this->default['chat']; ?>" value="<?php echo get_option('admin_site'); ?>" /> </td>
	    </tr>        

		<tr valign="top">
        <th scope="row"><label for="all"><?php _e("Available only for logged users", 'chatmeim-mini'); ?></label></th>
        <td><input type="checkbox" id="all" name="all" value="true" <?php checked('true', get_option('all')) ?> /></td>
        </tr>

		<tr valign="top">
        <th scope="row"><label for="mini_disable_mobile"><?php _e("Hide for mobile user", 'chatmeim-mini'); ?></label></th>
        <td><input type="checkbox" id="mini_disable_mobile" name="mini_disable_mobile" value="true" <?php checked('true', get_option('mini_disable_mobile')) ?> /></td>
        </tr>

        <tr valign="top">
        <th scope="row"><label for="priority"><?php _e("Priority", 'chatmeim-mini'); ?></label></th>
        <td>
        	<select id="priority" name="priority">
        		<option value="1" <?php selected('1', get_option('priority')); ?>><?php _e("Low", 'chatmeim-mini'); ?></option>
        		<option value="10" <?php selected('10', get_option('priority')); ?>><?php _e("Medium", 'chatmeim-mini'); ?></option>
        		<option value="100" <?php selected('100', get_option('priority')); ?>><?php _e("Height", 'chatmeim-mini'); ?></option>
       		</select>
        </td>
        </tr>

        <tr valign="top">
        <th scope="row"><label for="language"><?php _e("Mini Jappix language", 'chatmeim-mini'); ?></label></th>
        <td>
        <select id="language" name="language">
        <?php
        $auto_lng = (in_array(substr(get_locale(), 0, 2), $this->default['lngarray'])) ? substr(get_locale(), 0, 2) : $this->default['dlng'];
        ?>
        <option value="<?php echo $auto_lng ?>"><?php _e("Some of Site", 'chatmeim-mini'); ?></option>
        <option value="de" <?php selected('de', get_option('language')); ?>><?php _e("Deutsch", 'chatmeim-mini'); ?></option>
        <option value="en" <?php selected('en', get_option('language')); ?>><?php _e("English", 'chatmeim-mini'); ?></option>
        <option value="eo" <?php selected('eo', get_option('language')); ?>><?php _e("Esperanto", 'chatmeim-mini'); ?></option>
        <option value="es" <?php selected('es', get_option('language')); ?>><?php _e("Espa&ntilde;ol", 'chatmeim-mini'); ?></option>
        <option value="fr" <?php selected('fr', get_option('language')); ?>><?php _e("Fran&ccedil;ais", 'chatmeim-mini'); ?></option>
        <option value="it" <?php selected('it', get_option('language')); ?>><?php _e("Italiano", 'chatmeim-mini'); ?></option>
        <option value="ja" <?php selected('ja', get_option('language')); ?>><?php _e("Japan", 'chatmeim-mini'); ?></option>
        <option value="nl" <?php selected('nl', get_option('language')); ?>><?php _e("Nederlands", 'chatmeim-mini'); ?></option>
        <option value="pl" <?php selected('pl', get_option('language')); ?>><?php _e("Polski", 'chatmeim-mini'); ?></option>
        <option value="ru" <?php selected('ru', get_option('language')); ?>><?php _e("Russian", 'chatmeim-mini'); ?></option>
        <option value="sv" <?php selected('sv', get_option('language')); ?>><?php _e("Svenska", 'chatmeim-mini'); ?></option>
        <option value="hu" <?php selected('hu', get_option('language')); ?>><?php _e("Hungarian", 'chatmeim-mini'); ?></option>
        </select>
        </td>
        </tr>

	<tr valign="top">
        	<th scope="row"><label for="style"><?php _e('Custom Style', 'chatmeim-mini'); ?></label></th>
        	<td><textarea class="large-text code" aria-describedby="style-description" id="style" name="style" rows="4" cols="50"><?php echo wp_kses(get_option('style'),''); ?></textarea><br /> <p class="description" id="style-description"><?php _e('For Advance use try chat_html hook', 'chatmeim-mini') ?></p></td>
        </tr>

    </table>
    <?php submit_button(); ?>
    </form>
    <p><?php _e('For Ever request you can use our <a href="http://chatme.im/forums" target="_blank">forum</a>', 'chatmeim-mini') ?></p>

<h3 class="title"><?php _e('Donation', 'chatmeim-mini') ?></h3>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="8CTUY8YDK5SEL">
<input type="image" src="https://www.paypalobjects.com/en_US/GB/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal -  The safer, easier way to pay online.">
<img alt="" border="0" src="https://www.paypalobjects.com/it_IT/i/scr/pixel.gif" width="1" height="1">
</form>
</div>
<?php 
    }
} 

$Mini = Mini::getInstance();
?>